org.vishia.gral.awt

## Class AwtSubWindow

- java.lang.Object
- - org.vishia.gral.base.GralWidget.ImplAccess
  - - org.vishia.gral.base.GralPanelContent.ImplAccess
    - - org.vishia.gral.base.GralWindow.GraphicImplAccess
      - - org.vishia.gral.awt.AwtSubWindow

- All Implemented Interfaces:
    GralWidgImpl_ifc

      public class AwtSubWindow
      extends GralWindow.GraphicImplAccess
      implements GralWidgImpl_ifc

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `class` | `AwtSubWindow.GralAwtWindowAdapter`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `(package private) java.awt.event.ComponentListener` | `componentListener` The componentListener is the resize listener especially.
    `(package private) java.awt.event.HierarchyBoundsListener` | `hierarchyBoundsListener`
    `private boolean` | `isMainWindow`
    `(package private) java.awt.event.MouseListener` | `mouseListener`
    `(package private) java.awt.event.MouseMotionListener` | `mousMotionListener`
    `protected java.awt.Frame` | `window`
    `(package private) java.awt.event.WindowListener` | `windowClosingAdapter`
    `(package private) java.awt.event.WindowListener` | `windowListener`

    - ### Fields inherited from class org.vishia.gral.base.GralWindow.GraphicImplAccess

      `gralWindow`

    - ### Fields inherited from class org.vishia.gral.base.GralWidget.ImplAccess

      `chgBitsDerived, chgColorBack, chgColorLine, chgColorText, chgEditable, chgFloat, chgFocus, chgFont, chgIntg, chgInvisible, chgObjects, chgPos, chgText, chgVisible, chgVisibleInfo, pixBounds, wdgimpl, widgg`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `AwtSubWindow(GralWindow wdgGral)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `GralRectangle` | `getPixelPositionSize()` Returns the absolute position of this panel on screen and its size.
    `GralRectangle` | `getPixelSize()` Returns the size of this panel in pixel.
    `java.lang.Object` | `getWidgetImplementation()` Returns the implementation class of the widget.
    `void` | `removeWidgetImplementation()` Removes the graphical widget in the graphic.
    `void` | `repaintGthread()` This method should be implemented in all Widget implementations of the adapter for the underlying graphic system.
    `void` | `setBoundsPixel(int x, int y, int dx, int dy)`
    `boolean` | `setFocusGThread()` Sets the focus to the widget.
    `void` | `setVisibleGThread(boolean bVisible)` Sets the implementation widget vible or not.

    - ### Methods inherited from class org.vishia.gral.base.GralWindow.GraphicImplAccess

      `actionOnCloseWindow, getTitle, getWindowProps, isFullScreen, mouseAction, resizeAction, shouldClose`

    - ### Methods inherited from class org.vishia.gral.base.GralPanelContent.ImplAccess

      `gralPanel`

    - ### Methods inherited from class org.vishia.gral.base.GralWidget.ImplAccess

      `acknChanged, actionShow, dyda, getActionChange, getChanged, gralWidgetFromImplData, setDragEnable, setDropEnable, setFocused, setTextChanged, setVisibleState, XXXfocusGained`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### window

          protected final java.awt.Frame window

    - #### isMainWindow

          private final boolean isMainWindow

    - #### windowListener

          java.awt.event.WindowListener windowListener

    - #### windowClosingAdapter

          java.awt.event.WindowListener windowClosingAdapter

    - #### mousMotionListener

          java.awt.event.MouseMotionListener mousMotionListener

    - #### mouseListener

          java.awt.event.MouseListener mouseListener

    - #### hierarchyBoundsListener

          java.awt.event.HierarchyBoundsListener hierarchyBoundsListener

    - #### componentListener

          java.awt.event.ComponentListener componentListener

      The componentListener is the resize listener especially.

  - ### Constructor Detail

    - #### AwtSubWindow

          public AwtSubWindow(GralWindow wdgGral)

  - ### Method Detail

    - #### getPixelPositionSize

          public GralRectangle getPixelPositionSize()

      Description copied from class: `GralPanelContent.ImplAccess`
      Returns the absolute position of this panel on screen and its size. If it is a main window, the useable area of the window without title and menu bar is returned.
      Specified by:
        `getPixelPositionSize` in interface `GralWidgImpl_ifc`
      Specified by:
        `getPixelPositionSize` in class `GralPanelContent.ImplAccess`

    - #### getPixelSize

          public GralRectangle getPixelSize()

      Description copied from class: `GralPanelContent.ImplAccess`
      Returns the size of this panel in pixel.
      Specified by:
        `getPixelSize` in class `GralPanelContent.ImplAccess`
      Returns:
        the x and y is 0, the dy and dy is the size.

    - #### setBoundsPixel

          public void setBoundsPixel(int x,
                                     int y,
                                     int dx,
                                     int dy)

      Specified by:
        `setBoundsPixel` in interface `GralWidgImpl_ifc`

    - #### setFocusGThread

          public boolean setFocusGThread()

      Description copied from interface: `GralWidgImpl_ifc`
      Sets the focus to the widget. See `GralMng_ifc#setFocus(GralWidget)`.
      Specified by:
        `setFocusGThread` in interface `GralWidgImpl_ifc`
      Returns:
        true if it has the focus after this operation. false on any error.

    - #### setVisibleGThread

          public void setVisibleGThread(boolean bVisible)

      Sets the implementation widget vible or not.
      Specified by:
        `setVisibleGThread` in interface `GralWidgImpl_ifc`
      Parameters:
        `bVisible` - true then the widget should be visible, false it is set to invisible.
      See Also:
        `GralWidgImpl_ifc.setVisibleGThread(boolean)`

    - #### removeWidgetImplementation

          public void removeWidgetImplementation()

      Description copied from interface: `GralWidgImpl_ifc`
      Removes the graphical widget in the graphic.
      Specified by:
        `removeWidgetImplementation` in interface `GralWidgImpl_ifc`

    - #### repaintGthread

          public void repaintGthread()

      Description copied from interface: `GralWidgImpl_ifc`
      This method should be implemented in all Widget implementations of the adapter for the underlying graphic system.
      Implementation hints: In SWT it should call redraw().
      It is possible that the widget consists of more as one graphical widget, then all of it should be redrawn. It is possible that some data are set in another thread, they should be applied to the widgets firstly. It is possible that the widget is removed though a repaintGthread-order is pending from the time before deleting, for example if the graphic layout is changed.
      See `#repaintRequ`
      Specified by:
        `repaintGthread` in interface `GralWidgImpl_ifc`

    - #### getWidgetImplementation

          public java.lang.Object getWidgetImplementation()

      Description copied from interface: `GralWidgImpl_ifc`
      Returns the implementation class of the widget. If the widget has more as one implementation widgets, this method returns one of the widgets, usual the first important one respectively that widget which represents the implementation layer. A widget of the implementation layer is a SWT.control or a `Component`.
      If more as one widget are part of the GralWidget, use the special `GralWidget._wdgImpl` class which should contain the references to that implementation widgets.
      Specified by:
        `getWidgetImplementation` in interface `GralWidgImpl_ifc`